/***************************************************************************
 *   Copyright (C) 2005 by Roberto Cappuccio                               *
 *   robertoc@dnet.it                                                      *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef DLGCREATECATALOG_H
#define DLGCREATECATALOG_H

#include <kdialogbase.h>

#include "dlgmainwindow.h"
#include "katscanfolder.h"
#include "katinfoextractor.h"


class QTabWidget;
class QWidget;
class QLabel;
class KProgress;
class QButtonGroup;
class QPushButton;
class KTextEdit;
class QTime;
class DlgMainWindow;

class DlgCreateCatalog : public KDialogBase {
Q_OBJECT

public:
    DlgCreateCatalog( DlgMainWindow* parent, const char* name = 0, bool modal = false );
    ~DlgCreateCatalog();

public slots:
    void startScan();
    void updateScanDialog();
    void updateExtractDialog();

signals:
    void aborted();

private slots:
    virtual void scanCompleted();
    virtual void extractionCompleted();
    virtual void slotCancel();

private:
    DlgMainWindow* mf;
    KatCatalog* m_catalog;

    QTime m_start;
    QTimer *updateTimer;
    KatScanFolder* m_ksf;
    KatInfoExtractor* m_kie;

    QTabWidget* tabWidget;
    QLabel* tlMessage;
    QLabel* tlScanningFileLabel;
    QLabel* tlScanningFile;
    QLabel* tlScanningFolderLabel;
    QLabel* tlScanningFolder;
    KProgress* pProgress;
    QLabel* tlTimeFromStart;
    QButtonGroup* bgStats;
    QLabel* tlFiles;
    QLabel* tlFoldersNum;
    QLabel* tlFileSize;
    QLabel* tlFileSizeNum;
    QLabel* tlWordsNum;
    QLabel* tlFolders;
    QLabel* tlWords;
    QLabel* tlFilesNum;
    QLabel* tlMetaData;
    QLabel* tlMetaDataNum;
    QLabel* tlFullTexts;
    QLabel* tlFullTextsNum;
    QLabel* tlThumbnails;
    QLabel* tlThumbnailsNum;
    QLabel* pixmapLabel1;
    KTextEdit* teDetails;

};

#endif // DLGCREATECATALOG_H
