/***************************************************************************
 *   Copyright (C) 2005 by Roberto Cappuccio                               *
 *   robertoc@dnet.it                                                      *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef DLGLANGUAGEMANAGEMENT_H
#define DLGLANGUAGEMANAGEMENT_H

#include <kdialogbase.h>

class QPushButton;
class QTabWidget;
class QWidget;
class QListView;
class QListViewItem;
class QListBox;
class QListBoxItem;
class QLabel;
class KEditListBox;

class DlgLanguageManagement : public KDialogBase
{
    Q_OBJECT

public:
    DlgLanguageManagement( QWidget* parent = 0, const char* name = 0, bool modal = FALSE, WFlags fl = 0 );
    ~DlgLanguageManagement();

protected:
    void updateGUI(bool b);

protected slots:
    void addLanguage();
    void deleteLanguage();
    void createProfile();
    void deleteProfile();
    void addExclusion(const QString &);
    void deleteExclusion(const QString &);
    void selectLanguage( QListBoxItem* );

private:
    QStringList languages;
    QPushButton* bDeleteLanguage;
    QTabWidget* tabWidget;
    QWidget* Widget2;
    QPushButton* bDeleteLanguageProfile;
    QListView* lvLanguageProfile;
    QWidget* Widget3;
    QListBox* lbLanguages;
    QStringList m_languageFiles;
    QStringList m_exclusionFiles;
    KEditListBox* lbExclusions;
};

#endif // DLGLANGUAGEMANAGEMENT_H
