/*
 * output.c
 * Copyright (C) 2002-2004 A.J. van Os; Released under GNU GPL
 */

#include "antiword.h"

static conversion_type eConversionType = conversion_unknown;
static encoding_type eEncoding = encoding_neutral;

static void vPrologue1(diagram_type *pDiag, const char *szFilename) {

	options_type	tOptions;

	vGetOptions(&tOptions);
	eConversionType = tOptions.eConversionType;
	eEncoding = tOptions.eEncoding;
}

static void vEpilogue(diagram_type *pDiag) {
}

void vImagePrologue(diagram_type *pDiag, const imagedata_type *pImg) {
}

void vImageEpilogue(diagram_type *pDiag) {
}

BOOL bAddDummyImage(diagram_type *pDiag, const imagedata_type *pImg) {
	return FALSE;
}

diagram_type * pCreateDiagram(const char *szFilename, char* szBuffer)
{
	diagram_type *pDiag;

	pDiag = (diagram_type*)xmalloc(sizeof(diagram_type));
	pDiag->szOutBuffer = szBuffer;
    vPrologue1(pDiag, szFilename);
	return pDiag;
}

void vDestroyDiagram(diagram_type *pDiag) {
	if (pDiag == NULL) {
		return;
	}
	vEpilogue(pDiag);
	pDiag = (diagram_type*)xfree(pDiag);
}

void vPrologue2(diagram_type *pDiag, int iWordVersion) {
}

void vMove2NextLine(diagram_type *pDiag, draw_fontref tFontRef, USHORT usFontSize) {
    vMove2NextLineTXT(pDiag);
}

void vSubstring2Diagram(diagram_type *pDiag, 
	char *szString, size_t tStringLength, long lStringWidth,
	UCHAR ucFontColor, USHORT usFontstyle, draw_fontref tFontRef,
	USHORT usFontSize, USHORT usMaxFontSize)
{
	vSubstringTXT(pDiag, szString, tStringLength, lStringWidth);
	pDiag->lXleft += lStringWidth;
}

void vStartOfParagraph1(diagram_type *pDiag, long lBeforeIndentation) {
	vStartOfParagraphTXT(pDiag, lBeforeIndentation);
}

void vStartOfParagraph2(diagram_type *pDiag) {
}

void vEndOfParagraph(diagram_type *pDiag,
	draw_fontref tFontRef, USHORT usFontSize, long lAfterIndentation)
{
	vEndOfParagraphTXT(pDiag, lAfterIndentation);
}

void vEndOfPage(diagram_type *pDiag, long lAfterIndentation) {
	vEndOfPageTXT(pDiag, lAfterIndentation);
}

void vSetHeaders(diagram_type *pDiag, USHORT usIstd) {
}

void vStartOfList(diagram_type *pDiag, UCHAR ucNFC, BOOL bIsEndOfTable) {
}

void vEndOfList(diagram_type *pDiag) {
}

void vStartOfListItem(diagram_type *pDiag, BOOL bNoMarks) {
}

void vEndOfTable(diagram_type *pDiag) {
}

BOOL bAddTableRow(diagram_type *pDiag, char **aszColTxt,
	int iNbrOfColumns, const short *asColumnWidth, UCHAR ucBorderInfo)
{
	return FALSE;
}
