/***************************************************************************
 *   Copyright (C) 2005 by Roberto Cappuccio                               *
 *   robertoc@dnet.it                                                      *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef _KATDATABASEMANAGER_H_
#define _KATDATABASEMANAGER_H_

#include <sys/stat.h>
#include <stdlib.h>
#include <qvaluelist.h>
#include <qcstring.h>
#include <kfileitem.h>
#include <qstring.h>

#include "katcatalog.h"
#include "katinformation.h"
#include "cppsqlite3.h"


class extraInfo {
public:
    long fileId;
    long parentId;
};

class blobInfo {
public:
    int blobLen;
    QByteArray blobData;
};

class DlgMainWindow;

class KatDatabaseManager {
public:
    KatDatabaseManager(DlgMainWindow *_dm);
    virtual ~KatDatabaseManager();

    DlgMainWindow *mainWindow() const { return dm;}

    int createKatDatabase( const QString& );
    int openKatDatabase( const QString& );
    int closeKatDatabase();
    int readCatalogInformation( KatCatalog& kat );
    int saveCatalogInformation( KatCatalog& kat );
    long saveFileRecord( KFileItem* );
    int saveThumbnailRecord( int, QByteArray&, long );
    int saveMetaDataRecord( int, const QString& );
    int saveFullTextRecord( int, QByteArray&, long );
    int updateLanguageOfFile( int, QString& );

    blobInfo readFullTextRecord( long );
    int openTransaction();
    int commitTransaction();
    KatInformation readFileInformation( long );
    QMap<long,QString> getFileChildren( long );
    QMap<QString, long> readFiles( long, long );
    QValueList<int> doSearch( const QString&, bool, bool, bool );
    long getLastWordId();
    long getWordId( QString& );
    QMap<QString, long> readFileWords( long );
    long saveWordRecord( QString& );
    int saveWordfileRecord( long, long, long );
    QString readFullText( long );
    bool folderHasChildren( long );

private:
    CppSQLite3DB* db;
    DlgMainWindow *dm;
};

#endif //_KATDATABASEMANAGER_H_
